% x = h2a(X[,w]) - homogeneous to affine coordinates
% 
% X        ... homogeneous coordinates in columns
% w(i) = 0 ... point at infinity
% x        ... affine coordinates in columns

% (c) T.Pajdla, www.neovision.cz, Sep 10, 2004
function x = h2a(X,w)

if nargin<2
    w = ones(1,size(X,2));
end
w      = logical(w(:));
x      = X(1:end-1,:);
xe     = X(end,:);
if size(x,2)>1
    if any(w)
        x(:,w) = x(:,w)./(ones(size(x,1),1)*xe(w));
    end
elseif w
    x = x./(ones(size(x,1),1)*xe');
end