/*
An example of the use of the R6P solver

Please, refer to the following paper:

Cenek Albl, Zuzana Kukelova, Tomas Pajdla;
Rolling Shutter Absolute Pose Problem With Known Vertical Direction
The IEEE Conference on Computer Vision and Pattern Recognition (CVPR),
2016, pp. 3355-3363

Copyright (c) 2015, Cenek Albl <alblcene@cmp.felk.cvut.cz> and Zuzana Kukelova <zukuke@microsoft.com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
* Neither the names of the Czech Technical University and Microsoft nor the
names of its contributors may be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL COPYRIGHT HOLDERS BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "r5pup.h"

int main(int argc, char ** argv){


	Eigen::VectorXd X5(3 * 5);
	Eigen::VectorXd u5(2 * 5);
	Eigen::Vector3d g;

	double resC[60], rest[60], resw[60], resR[180];
	int nresults;

	// 5 3D points
	X5 << 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 1.0, 0.0, 0.8571428571428572, 0.8571428571428572, 0.0;
	// 5 corresponding 2D image points
	u5 << 0.1451672911643982, 0.05730046331882477, -0.09263340383768082, 0.16920527815818787, -0.2036127895116806, -0.05498022586107254, 0.017261890694499016, -0.1403426080942154, 0.007905835285782814, -0.1036616712808609;
	// direction of gravity in the camera frame x,y,z
	g << 0.31912997, 4.570478, 8.670598;




	
	nresults = r5p(g.data(), X5.data(), u5.data(), 0.0, 1, resC, rest, resR, resw);
	

	
}